#ifndef MYTH_MEDIA_MONITOR_DARWIN_H
#define MYTH_MEDIA_MONITOR_DARWIN_H

#include <DiskArbitration/DiskArbitration.h>
#include "mythmedia.h"
#include "mythmediamonitor.h"

extern "C" void diskAppearedCallback(DADiskRef disk, void *context);
extern "C" void diskDisappearedCallback(DADiskRef disk, void *context);
extern "C" MediaType MediaTypeForBSDName(const char *bsdName);

class MonitorThreadDarwin : public MonitorThread
{
  public:
    MonitorThreadDarwin( MediaMonitor* pMon,  unsigned long interval);
    virtual void run(void);

    void registerDiskArbitrationCallbacks();
    void unregisterDiskArbitrationCallbacks();
    void diskAppeared(QString devName);
    void diskDisappeared(QString devName);

  protected:
    void *m_DiskArbitrationSession;         // Really a DASessionRef, but the void* here lets us avoid Mac Headers in this file 8-)
};

class MediaMonitorDarwin : public MediaMonitor
{
    friend class MediaMonitor;
    
    protected:
      MediaMonitorDarwin(QObject* par, unsigned long interval, bool allowEject) : MediaMonitor(par, interval, allowEject) {}

    public:
        virtual void StartMonitoring(void);
    protected:
        virtual bool AddDevice(MythMediaDevice* pDevice);
};
#endif // MYTH_MEDIA_MONITOR_DARWIN_H
